local addon, shared = ...

---------------------
-- Variables
---------------------

_raidbuffWatcher = {}
--/script dump(_raidbuffWatcher.visBuff)
local RBW = _raidbuffWatcher
local _playerID = nil
local ct = 0

RBW.RaidID = {}

RBW.Frames = {}
RBW.visBuff = {}
RBW.buffWatch = {}

local unitDetails = {}
local lastUpdate = 0
local activeBuffID = {}

local lastseen = {}

local RBW_MAX_BUFF=32

local default_settings = {
	x=(UIParent:GetWidth()-292)/2,
	y=UIParent:GetHeight()/2,
	buffList = {
		"Toinenveli's Ire", "Kolmasveli's Ire"
		},
	buffHistory = {buff={}, dbuf={}}, sort = "BPD"
}

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}				
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

local function _buildbuffWatch()
	RBW.buffWatch = {}
	for _,v in pairs(RBW_Settings.buffList) do
		RBW.buffWatch[v] = true
	end
end

function RBW.SlashHandler(h, args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		r[numargs] = token
		numargs=numargs+1
	end
	if numargs>0 then
		if r[0] == "list" then
			for k,v in ipairs(RBW_Settings.buffList) do
				print(k.." : "..v)
			end
		elseif r[0] == "add" then
			if numargs>=2 then
				local s = r[1]
				for i = 2, numargs-1 do
					s = s.." "..r[i]
				end
				local found = false
				for _,v in pairs(RBW_Settings.buffList) do
					if v == s then
						found = true
					end
				end
				if found then
					print ("'"..s.."' already in watchlist")
				else									
					table.insert(RBW_Settings.buffList, s)
					_buildbuffWatch()
					print ("Adding '"..s.."' to watchlist")
				end
			else
				print "Nothing specified to add"
			end
		elseif r[0] == "remove" then
			if numargs >=2 then
				local s = r[1]
				for i = 2, numargs-1 do
					s = s.." "..r[i]
				end
				for k,v in ipairs(RBW_Settings.buffList) do
					if (k == tonumber(s)) or (v==s) then
						table.remove(RBW_Settings.buffList, k)
						_buildbuffWatch()
						print("Removed '"..v.."' at #"..k)
						lastUpdate = 0
					end
				end
			else
				print "Nothing specified to remove"
			end
		elseif r[0] == "sort" then
			if numargs == 2 then
				if r[1] == "BPD" or r[1] == "BDP" or r[1] == "DBP" or r[1] == "DPB" or r[1] == "BDP" or r[1] == "BPD" then
					RBW_Settings.sort = r[1]
					RBW.UpdateSort()
				else
					print("Invalid sort order: "..r[1])
				end
			else
				print("Current sort order: "..RBW_Settings.sort)
			end
		end
	else
		print "RBW:"
		print "\t/rbw list - lists watched buffs"
		print "\t/rbw add \"name of buff\" - adds a new buff to list"
		print "\t/rbw remove ##|\"name of buff\" - removes a buff from list"
		print "\t/rbw sort [order] - where order is a combination of B (BuffName), P (Player), D (Duration)"
	end
end

function RBW.Addon_SavedVariables_Load_End(h,a)
	if a == addon.identifier then
		if RBW_Settings == nil then RBW_Settings = {} end
		MergeTable(RBW_Settings, default_settings)
		
		for k,v in pairs(RBW_Settings) do
			if default_settings[k] == nil then
				RBW_Settings[k] = nil
			end
		end
		
		_buildbuffWatch()
		RBW.BGFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RBW_Settings.x, RBW_Settings.y)
	end
end

function RBW.Event_Buff_Add(h,u,t)
	if RBW.RaidID[u] then
		if not unitDetails[u] then
			unitDetails[u] = Inspect.Unit.Detail(u)
		end
		ct = Inspect.Time.Real()
		
		local expire = 0
		local stack = nil
		
		for k,v in pairs(Inspect.Buff.Detail(u,t)) do
			if RBW.buffWatch[v.name] then
				if v.debuff then
					RBW_Settings.buffHistory.dbuf[v.name] = true
				else
					RBW_Settings.buffHistory.buff[v.name] = true
				end
				if not unitDetails[v.caster] then
					local ud = Inspect.Unit.Detail(v.caster)
					if ud then 
						unitDetails[v.caster] = ud
					end
				end
				local src="UNKNOWN SOURCE"
				if unitDetails[v.caster] then
					src = unitDetails[v.caster].name
				end
				local trg="UNKNOWN TARGET"
				if unitDetails[u] then
					trg=unitDetails[u].name
				end
				
				stack = v.stack
				
				if v.remaining then
					expire = ct + v.remaining
				else
					expire = 99999999
				end
			
				activeBuffID[k] = true
				local pn = unitDetails[u].name or "UNKNOWN!"
				local sk = RBW.GetSortKey(pn, v.name, expire)
				table.insert(RBW.visBuff, {b=k, i=u, n=v.name, un=pn, ic=v.icon, sk=pn.."."..v.name.."."..k, stk=stack, xt=expire, dbf=v.debuff})
				lastUpdate = 0
			end
		end
	end
end

function RBW.UpdateSort()
	for k,v in pairs(RBW.visBuff) do
		v.sk = RBW.GetSortKey(un, n, xt)
	end
end

function RBW.GetSortKey(p, b, d)
	if		RBW_Settings.sort == "BPD" then return string.format("%s.%s.%s", b, p, d)
	elseif RBW_Settings.sort == "BDP" then return string.format("%s.%s.%s", b, d, p)
	elseif RBW_Settings.sort == "PBD" then return string.format("%s.%s.%s", p, b, d)
	elseif RBW_Settings.sort == "PDB" then return string.format("%s.%s.%s", p, d, b)
	elseif RBW_Settings.sort == "DBP" then return string.format("%s.%s.%s", d, b, p)
	elseif RBW_Settings.sort == "DPB" then return string.format("%s.%s.%s", d, p, b)
	end
end

function RBW.Event_Buff_Remove(h,u,t)
	if RBW.RaidID[u] then
		for k,_ in pairs(t) do
			if activeBuffID[k] then
				activeBuffID[k] = nil
			end
		end
		lastUpdate = 0
	end
end

function RBW.Event_Buff_Change(h,u,t)
	if RBW.RaidID[u] then
		for k,_ in pairs(t) do
			if activeBuffID[k] then
				print("ID: "..k.." changed:")
				dump(Inspect.Buff.Detail(u,k))
			end
		end
	end
end

function RBW.CreateFrame(v)
	local f = UI.CreateFrame("Frame", "RBW.RBWFrame:"..v, RBW.context)
	f:SetVisible(false)
	f:SetHeight(24)
	f:SetWidth(192)
	f:SetLayer(0)
	if v==1 then
		f:SetPoint("TOPLEFT", RBW.BGFrame, "TOPLEFT", 17,1)
	else
		f:SetPoint("TOPLEFT", RBW.Frames[v-1].f, "BOTTOMLEFT", 0,0)
	end
	local i = UI.CreateFrame("Texture", "RBW.RBWIcon:"..v, f)
	i:SetHeight(24)
	i:SetWidth(24)
	i:SetPoint("TOPRIGHT", f, "TOPLEFT", 0,0)
	i:SetLayer(1)
	local it = UI.CreateFrame("Text", "RBW.TextS:"..v, f)
	it:SetHeight(24)
	it:SetWidth(24)
	it:SetBackgroundColor(0,0,0,0.5)
	it:SetPoint("CENTER", i, "CENTER", 0,0)
	it:SetFontColor(1,1,1,1)
	it:SetFontSize(16)
	it:SetLayer(2)
	local s = UI.CreateFrame("Frame", "RBW.RBWSolid:"..v, f)
	s:SetHeight(24)
	s:SetWidth(192)
	s:SetPoint("TOPLEFT", f, "TOPLEFT", 0,0)
	s:SetLayer(2)
	local t = UI.CreateFrame("Text", "RBW.TextA:"..v, f)
	t:SetHeight(24)
	t:SetWidth(192)
	t:SetPoint("CENTERLEFT", f, "CENTERLEFT", 0,0)
	t:SetFontColor(1,1,1,1)
	t:SetFontSize(14)
	t:SetAlpha(1)
	t:SetLayer(3)
	
	RBW.Frames[v] = {f=f, i=i, it=it, s=s, t=t}
end

local skipped=0

local _raidNames = {
	"group01", "group02", "group03", "group04", "group05",
	"group06", "group07", "group08", "group09", "group10",
	"group11", "group12", "group13", "group14", "group15",
	"group16", "group17", "group18", "group19", "group20",
	"player"
	}

function RBW.Event_System_Update_Begin(h)
	local curUpdate = Inspect.Time.Real()
	if curUpdate - lastUpdate < 0.5 then
		return
	end
	lastUpdate = curUpdate
	
	RBW.RaidID = {}
	
	for k,v in pairs(_raidNames) do
		local pid = Inspect.Unit.Lookup(v)
		if pid then
			RBW.RaidID[pid] = v
		end
	end
	
	for x=#RBW.visBuff, 1, -1 do
		if (RBW.RaidID[RBW.visBuff[x].i] == nil) or (RBW.visBuff[x].xt and RBW.visBuff[x].xt < curUpdate) or (activeBuffID[RBW.visBuff[x].b] == nil) then
			activeBuffID[RBW.visBuff[x].b] = nil
			table.remove(RBW.visBuff, x)
		end
	end
	
	table.sort(RBW.visBuff, function(a,b) return a.sk < b.sk end)
	
	local bfcnt= math.min(#RBW.visBuff, RBW_MAX_BUFF)

	for x=1, bfcnt do
		k=x
		v=RBW.visBuff[x]

		RBW.Frames[x].f:SetVisible(true)
		local dt=""
		local br=0
		local bw=1
		if v.xt then
			br = v.xt - curUpdate
			if br <= 60 then
				dt = string.format(" [%ds]", br)
				bw = br/60				
			end
		end
		RBW.Frames[x].s:SetWidth(math.floor(bw*192))		
		RBW.Frames[x].t:SetText(string.format("%s (%s)%s",v.n,v.un,dt))
		RBW.Frames[x].i:SetTexture("Rift", v.ic)

		if v.stk then
			RBW.Frames[x].it:SetVisible(true)
			RBW.Frames[x].it:SetText(tostring(v.stk))
		else
			RBW.Frames[x].it:SetVisible(false)
		end
		if v.dbf ~= nil then
			RBW.Frames[x].s:SetBackgroundColor(0.75,0,0)
		else
			RBW.Frames[x].s:SetBackgroundColor(0,0,0.75)
		end
	end

	for i = bfcnt+1, RBW_MAX_BUFF do
		RBW.Frames[i].f:SetVisible(false)
	end
	RBW.BGFrame:SetHeight((32*bfcnt)+4)
	if bfcnt > 0 then
		RBW.BGFrame:SetVisible(true)
	else
		RBW.BGFrame:SetVisible(false)
	end
end

function RBW.BuildUI()
	RBW.context = UI.CreateContext(addon.identifier)
	RBW.BGFrame = UI.CreateFrame("Frame", "RBW.BGFrame", RBW.context)
	RBW.BGFrame:SetVisible(false)
	RBW.BGFrame:SetHeight(0)
	RBW.BGFrame:SetWidth(292)
	RBW.BGFrame:SetLayer(-1)

	RBW.BGFrame:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - RBW.BGFrame:GetLeft()
		self.sy = mouseData.y - RBW.BGFrame:GetTop()
	end, "Event.UI.Input.Mouse.Left.Down")
	
	RBW.BGFrame:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			RBW.BGFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end, "Event.UI.Input.Mouse.Cursor.Move")
	
	RBW.BGFrame:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		if self.MouseDown then
			self.MouseDown = false
		end
		RBW_Settings.x = RBW.BGFrame:GetLeft()
		RBW_Settings.y = RBW.BGFrame:GetTop()
	end, "Event.UI.Input.Mouse.Left.Up")
	
	for x=1, RBW_MAX_BUFF do
		RBW.CreateFrame(x)
	end
end

---------------------
-- Register Events
---------------------
RBW.BuildUI()

Command.Event.Attach(Command.Slash.Register("rbw"), RBW.SlashHandler, "Command.Slash.Register")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, RBW.Addon_SavedVariables_Load_End, "Event.Addon.SavedVariables.Load.End")
Command.Event.Attach(Event.System.Update.Begin, RBW.Event_System_Update_Begin, "Event.System.Update.Begin")
Command.Event.Attach(Event.Buff.Add, RBW.Event_Buff_Add, "Event.Buff.Add")
Command.Event.Attach(Event.Buff.Remove, RBW.Event_Buff_Remove, "Event.Buff.Remove")

_playerID = Inspect.Unit.Lookup("player")
RBW.RaidID[_playerID] = "player"

print(string.format("v%s loaded. Type /rbw to see options.", addon.toc.Version))
ct = Inspect.Time.Real()